// STARTER CODE NOTE: 
//  - The file players.js is part of the starter and your solution; it goes:
//      let builtInPlayerList = [ ... ];
//  - This variable is usable by your code here, just like P5's "width."
//  - You should write a comment at the start of this file explaining how you
//    are using builtInPlayerList, as if it were your own declaration.  Such
//    a comment, which explains how the starter code uses it, follows.  You
//    are required to use it differently, so your comment will be different.
//    You are given freedom to decide how you will use it, so your comment
//    needs to explain your choices.


// BEGIN TEMPORARY STARTER CODE: student to modify this comment

    // builtInPlayerList is an array of player records, initially populated with
    // all known players.  The program never adds to, removes from, or reorders
    // these players.  The program adds attributes to each player, representing
    // the card's x-y position on the screen.

// END TEMPORARY STARTER CODE


// BEGIN TEMPORARY STARTER CODE: student must remove this declaration entirely

    // the image of Sidney Crosby
    let TEMP_sidneyCrosbyImage;

// END TEMPORARY STARTER CODE


function preload() {
  TEMP_sidneyCrosbyImage = loadImage('data/Sidney_Crosby.jpg');
}

function setup() {
  // canvas is initially full-tab
  createCanvas(windowWidth, windowHeight);

  resizeImageForCard(TEMP_sidneyCrosbyImage, CARD_WIDTH, CARD_HEIGHT - CARD_IMAGE_YOFF);

  // BEGIN TEMPORARY STARTER CODE: student must replace the attributes
  //                               TEMP_x/y with zero or more appropriate ones

      // place card at fixed random location on the screen
      for (let i = 0; i < builtInPlayerList.length; i++ ) {
        let p = builtInPlayerList[i];
        p.TEMP_x = random(width - CARD_WIDTH);
        p.TEMP_y = random(height - CARD_HEIGHT);
      }

  // END TEMPORARY STARTER CODE
}

// keep up with full tab
function windowResized() {
  resizeCanvas(windowWidth, windowHeight);
}

function draw() {
  background(255);
  drawCards();
}

const CARD_WIDTH = 100;
const CARD_HEIGHT = 162;

const CARD_TEXT_XOFF = 20;
const CARD_TEXT_FNAME_YOFF = 20;
const CARD_TEXT_LNAME_YOFF = 40;

const CARD_IMAGE_YOFF = 50;

// modifies the provided image such that its aspect ratio is preserved and
// its size fits within a maxWidth-by-maxHeight box
function resizeImageForCard(img, maxWidth, maxHeight) {
  // STARTER CODE NOTE: student is encouraged to leave this declaration and
  //                    body as-is

  let containmentAspectRatio = maxWidth / maxHeight;
  let imageAspectRatio = img.width / img.height;
  if (containmentAspectRatio < imageAspectRatio) {
    // constrained by width
    img.resize(maxWidth, 0);
  } else {
    // constrained by height
    img.resize(0, maxHeight);
  }
}

// STARTER CODE NOTE: functionality here has to change; student is free to:
//                    - keep this declaration
//                    - remove/replace it, or
//                    - change its parameters
function drawCards() {
  for (let i = 0; i < builtInPlayerList.length; i++ ) {
    let p = builtInPlayerList[i];
    drawOneCard(p, p.TEMP_x, p.TEMP_y);
  }
}

// STARTER CODE NOTE: student is encouraged to keep this declaration as-is,
//                    but modify the body
function drawOneCard(card, x, y) {
  stroke(30, 30, 100);
  fill(255, 255, 255);
  rect(x, y, CARD_WIDTH, CARD_HEIGHT);

  fill(30, 30, 100);
  noStroke();
  text(card.FirstName, x+CARD_TEXT_XOFF, y+CARD_TEXT_FNAME_YOFF);
  text(card.LastName, x+CARD_TEXT_XOFF, y+CARD_TEXT_LNAME_YOFF);

  if (card.FirstName==='Sidney'&&card.LastName==='Crosby') {
    let imageXoff = (CARD_WIDTH - TEMP_sidneyCrosbyImage.width) / 2;
    let imageYoff = (CARD_HEIGHT - TEMP_sidneyCrosbyImage.height);
    image(TEMP_sidneyCrosbyImage, x + imageXoff, y + imageYoff);
  }
}
